---

QueryTheme: Social
QueryAddedDate: 2021
QueryLanguage:
QueryAuthor:
QueryPublishedD:
QueryReadD:
Alias: ["Reading", "Reading list"]
Tag: ["Lifestyle", "LifeHacks", "Book"]
Date: 2021-09-25
DocType: "Personal"
Hierarchy: "Root"
location: [51.514678599999996, -0.18378583926867909]
CollapseMetaTable: Yes

---

Parent:: [[Lifestyle]]

---

&emsp;

```button
name Create New Note
type note(New Note) template
action Template Note
id NewNote
```
^button-ReadingNewNote

```button
name Create New Source
type note(New Source) template
action Template Source
id NewNote
```
^button-ReadingNewSource

```button
name Save
type command
action Save current file
id Save
```
^button-ReadingMSave

&emsp;

# Folder map
&emsp;

```ad-abstract
title: Summary
collapse: open
This note enables to navigate all books and readings in this Vault.
```

&emsp;

```toc
style: number
```

&emsp;

---

&emsp;

### Quick Filter

&emsp;

```button
name Search Library
type command
action MetaEdit: Run MetaEdit
id EditMetaData
```

&emsp;

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {dateadded: dv.current().QueryAddedDate, language: dv.current().QueryLanguage, author: dv.current().QueryAuthor, publicationd: dv.current().QueryPublishedD, theme: dv.current().QueryTheme, readingd: dv.current().QueryReadD})
```

&emsp;

---

&emsp;

### Unread books

&emsp;

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {readingd: false})
```

&emsp;

---

&emsp;

### Read books
&emsp;

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {readingd: true})
```

&emsp;

---

&emsp;

### Navigation by language

&emsp;
&emsp;

#### French literature

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {language: "FR"})
```

&emsp;

---

&emsp;

#### English literature

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {language: "EN"})
```

&emsp;

---

&emsp;

#### International literature

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {language: "BR"})
```

&emsp;

---

&emsp;

### Navigation by type

&emsp;
&emsp;

#### Novel

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {theme: "Novel"})
```

&emsp;

---

&emsp;

#### Essay

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {theme: "Essay"})
```

&emsp;

---

&emsp;

#### Biography

```dataviewjs
dv.view("00.01 Admin/dv-views/book_query", {theme: "Biography"})
```

&emsp;

---

&emsp;

### Tag Navigation
&emsp;

```dataview
	Table without id tags as "Tags"
	where Source.Type = "Book"
	Flatten file.tags as tags
	Group by tags
```

&emsp;

---

&emsp;

### High Level tasks

&emsp;

&emsp;
&emsp;